%This script runs Example IV in the paper.  

%load the signal
[wave,fs]=audioread('Cooperative/Signals/piazzola4_piece.wav');
signal=wave(:,1); %monochanel
FrameLength=1024; %block size, in the paper 'Nb'
bw=FrameLength;
[s1,s2]=size(signal);

if s1 >s2 signal=signal';end

MaxNum=124300 %Numer of atoms for the total approximation

s=floor(numel(signal)/bw);
mf=signal(1:s*bw);%resize the signal to be divisible by bw
Nx=numel(mf);
Nframe=Nx/bw; %number of frames (in the paper called blocks)
%
t0=1;
for j=1:Nframe;
t=t0:t0+bw-1;
t0=t0+bw;
cmf{j}=mf(t);
end
%randomnization of the frames (blocks) possition
ib=1:Nframe;
seedi=7;%change this number for a different realization.
rand('state',seedi); ip=randintrlv(ib,seedi);
f=[];
for i=1:Nframe
f=[f cmf{ib(ip(i))}];
end
icase=4
clear dre dim eex D nord
%
%Segmenting the signal into grous of Ns segments of width bws
a=2%redundancy, for Sin and Cos dictionaries
Lx=bw;
dre=DCos(Lx,a*Lx,a); %creates dictionry of cosines
dim=DSin(Lx,a*Lx,a); %creates dictionaries of sines
%
%
for i=1:a*Lx; nord(1,i)=norm(dre(:,i)); nord(2,i)=norm(dim(:,i));end

dre=NormDict(dre); 
dim=NormDict(dim);

D=[dre dim];      %redundant  cosine and sine dictionary 

[FrameLength, N]=size(D);
M=N/2
k=1:M;
eex(1,:)=exp(-pi*1i*(k-1)/(2*M))./nord(1,:);
eex(2,:)=exp(-pi*1i*(k)/(2*M))./nord(2,:);
%
tic
tol3=0 %approximate up to the required sparisty
%
bws=numel(f)/50;
[cmfs,Ns,f2]=BlockSignal(f,bws); %divide the signal into segments of length bws
%
No=MaxNum/Ns; %equal sparsity for each segment
%
fap=[];
B=[];
Cnat=0;
tic
for j=1:Ns;
[B,NBl,f2]=BlockSignal(cmfs{j}',bw);
%
[h,Di1,beta,c,Q,Nat,NorQ]=OHBW_OOMP_FFT(B,D,tol3,No,eex,icase); %approximate with HBW-OMP each segment
%
%=====================================================================
%reconstraccion
      for i=1:NBl
        fap=[fap;h{i}];%get the approximated signal from the segments 
      end
Cnat=Cnat+Nat;
end
%
%Invert the randonization of the blocks
 [cmfa,NFrame,fap]=BlockSignal(fap,bw);
 for i = 1:NFrame
   cmfar{ib(ip(i))}=cmfa{i};
 end
fa=[];
for i=1:NFrame
fa=[fa cmfar{i}]; %recover the approximated signal in original form
end
fprintf('HBW-OMP Sparsity Ratio SR.\n');
SR= numel(mf)/Cnat% Sparsity ratio
%MSE=norm(mf-fa)^2/numel(mf) % of the approximation
%nCoe=Cnat
fprintf('HBW-OMP Approximation quality SNR.\n');
SNR= CalcSNR(mf,fa) %quality of the approximation
toc
